package com.tencent.qqmusic.third;

//实现该回调接口时注意, 函数内不能有耗时操作, 如有耗时操作应新启子线程进行处理
interface IQQMusicCallbackForThird
{
	//当播放的歌曲改变的时候以及歌曲的播放状态改变或者歌曲的图片以及歌词有改变的时候都会回调
	void onPlaySongChanged();
	
	//当播放列表改变时候会回调
	void onPlayListChanged();
	
	//当播放列表中的专辑url或者专辑本地路径发生变化时候会回调
	void onPlayListUpdate();
	
	//当qq音乐退出或者有其他情况时候回调
	void onServiceDestory();

	//歌词回调  transLyric 为保留字段,目前返回空
    void onLyricLoaded(boolean succ, String lyric, String transLyric);

   //图片回调, localPath 图片的本地地址,如果 succ为false 或 localPath为空, 则需要用 imageUrl从网络自行获取
    void onImageLoaded(boolean succ, String imageUrl,String localPath);
}