package com.tencent.qqmusicplayerprocess.servicenew;

import java.util.List;
import com.tencent.qqmusicplayerprocess.songinfo.SongInfo;
import com.tencent.qqmusicplayerprocess.audio.playlist.MusicPlayList;
import com.tencent.qqmusicplayerprocess.audio.playlist.AsyncLoadList;
import com.tencent.qqmusicplayerprocess.servicenew.IQQPlayerThirdCallback;
import com.tencent.qqmusicplayerprocess.audio.playlist.PlaylistListener;
import com.tencent.qqmusicplayerprocess.audio.progresshelp.ProgressInterface;
import com.tencent.qqmusicplayerprocess.servicenew.IMainProcessInterface;
import com.tencent.qqmusicplayerprocess.session.Session;
import com.tencent.qqmusiccommon.storage.StorageVolume;
import com.tencent.qqmusicplayerprocess.conn.IDtsCallback;
import com.tencent.qqmusic.business.online.PublicRadioList;
import com.tencent.qqmusic.mediaplayer.AudioInformation;
import com.tencent.qqmusicplayerprocess.servicenew.OnFFTDataCaptureListener;
import com.tencent.qqmusic.landscape.SpectrumData;
import com.tencent.qqmusicplayerprocess.qplayauto.QPlayAutoContentItem;
import com.tencent.qqmusicplayerprocess.servicenew.IQQPlayerOpenCallback;
import com.tencent.qqmusiccommon.statistics.StaticsList;
import com.tencent.qqmusicplayerprocess.audio.dts.AccessoryDescriptor;
import com.tencent.qqmusiccommon.util.music.ExtraInfo;

interface IQQPlayerServiceNew
{

	int play(int from, long timestamp);
	int stop(int from);
	int stopWithFadeOut(int from);
	int pause(int from);
	int resume(int from);
//	int touch();
	int prev(int from, long timestamp);
	int next(int from, long timestamp);
	long seek(long s, int from);
	int playPos(int pos, int from, long timestamp);
	int setPlayList(in MusicPlayList playlist, in SongInfo songinfo, int from);
	int setPlayMode(int playMode, int from);
	int getCurPlayPos();
	SongInfo getPreSong();
	SongInfo getNextSong();
	int getPlayState();
	int getBufferState();
	boolean isPlayingForEngine();
	boolean isPlayingForUI();
	long getTotalLength();
	long getBufferLength();
	int getBufferPercent();
	long getCurrTime();
	long getDuration();
	int getPlayMode();
	int getGlobalPlayMode();
	oneway void setPlayPath(String path, boolean needSave);
	oneway void setTJReport(String report);
	void setTJTJReport(String report);
	oneway void loadRadioListError(in AsyncLoadList playList);
	oneway void loadRadioListSuc(in AsyncLoadList playList, in List<SongInfo> songs, int pos);
	oneway void setRadioList(in PublicRadioList radioList);
	boolean intentReceiverOnReceiveWithAudioManagerForQplay(in Intent intent);
	oneway void continueDownloadForNetWorkAvailable();
	oneway void continueDownload();
	SongInfo getPlaySong();
	int initPlayListAndPlay(in MusicPlayList playList, in SongInfo song, int from, long timestamp);
	int initPlayListAndPlayUsePos(in MusicPlayList playList, int songPos, int from, int playMode, long timestamp);
    int initPlayListAndPlayBySingleRadio(in MusicPlayList playList, int from, long timestamp);
	oneway void onLogout();
	boolean isSongInfoInSamePlayList(in MusicPlayList playList);
	int getSongPos(in SongInfo song);
	MusicPlayList getPlayList();
	oneway void deleteSong(in MusicPlayList list);
	oneway void deleteSongNotExist(in MusicPlayList list);
	oneway void eraseAndDeleteQPlaySong(in SongInfo song);
	oneway void addToList(in MusicPlayList playList);
	int getPlayFocus();
	boolean needDownloadSongToPlayOnline();
	boolean isNullPlayList();
	int getSongBitRate();
	boolean isUseUrlPlayer();
	int playHigherQuality(int quality, long timestamp);
	int clearPlayList();
	oneway void eraseMutilSongs(in List<SongInfo> mMutilChoiceSongList);
	oneway void delSongsAndPlayRadio(in List<SongInfo> mMutilChoiceSongList);
	oneway void setHasShow2g3g(boolean hasShow2g3g);
	int getPlayListType();
	long getPlayListTypeId();
	String getPlayListFolderName();
	long getPlayListFolderId();
	int getPlayListSize();
	oneway void loadLastList();
	void setPlayListPartially(in MusicPlayList playList);
	void addPlayListPartially(in MusicPlayList playList);
    List<SongInfo> getRadioHistoryList();
    boolean isInNextPlaySongList(in SongInfo song);
    int getNextSongListNum();
    String getRadioName();
    String getRadioUrl();
    long getRadioId();
    oneway void popSongFromHistory(in SongInfo song);
    oneway void deleteRadioSong(in SongInfo song);
    SongInfo getSingleRadioSong();
	oneway void clearCache();
	oneway void setOnlinePlayerCacheLimit(int limit);
	boolean updatePlayListAndPlay(in SongInfo newSongInfo,int index, int from); //rubik 新增：更新播放歌曲信息
	
	//For vKey
	String getServerCheck();
	int urlCannotDownload(String url, int respCode);
	oneway void networkChangedForVkey();
	String getSpeedTestUrl();
	String getVKey();
	String getContKey(String filename,int ipaid);
	String getVKeyPair();
	String getVKeyUin();
	String getVKeyForWX(String guid);
	oneway void forceToUpdateVkey();

	//For sdcard 
	boolean isSdcardAvailable();
	String getSdCardState();
	
	List<String> getStoragePaths();
	List<String> getRawStoragePaths();
	List<StorageVolume> getStorageVolumes();
	boolean setBigDataStoragePath(String path);
	String getStoragePath();
	String getBigDataStoragePath();
	String getMainPath();
	String getBigDataMainPath();
	String getFilePath(int index);
	String getBackupLocationPath(String p);
	
	//For statistics manager
	long getSendFrequence();
	oneway void setSendFrequence(long fre);
	oneway void debugSendLog();
	oneway void pushLog(String logInfo, boolean force);
	oneway void pushFrom(int curIndex);
	oneway void popFromByIndex(int curIndex);
	oneway void popFrom();
	String from();
	int getLatestPathPoint();
	String fromPrePath(boolean needPrePath);
	oneway void setPrePath(String path);
	
	//For session
	String getbuluoUrl();
	
	String getDTSVer();
	String getDTSUrl();
	String getDTSMd5();
	long getDTSSize();
		
	boolean isForbiddenIP();
	boolean isPushFlag();
	boolean isReady();
	oneway void needReloadSession(int callerState);
	oneway void needReLoadSession();
	String pack(String content);
    oneway void sendAuthenticationBroadcast(String content);
    Session getSessionInstance();
    oneway void readSessionFromDB();
	
	oneway void setProgressInterface(ProgressInterface progressInterface, int fromKey);
	oneway void removeProgressInterface(int fromKey);
    
    oneway void registerCallback(PlaylistListener listener);
    oneway void unRegisterCallback(PlaylistListener listener);
    
    oneway void registerMainProcessInterface(IMainProcessInterface iface);
    oneway void unRegisterMainProcessInterface(IMainProcessInterface iface);
      
    boolean isHeadsetPlauged();
    oneway void setVolume(float vol);
    oneway void showPlayNotification();
    oneway void onLoginStateChanged(String curStringQQNum);
    boolean isSupportDTS();

    String getLastDisabledSfxModuleId();
    boolean initDTSLibrary();
    boolean turnDTSOn(boolean on);
    boolean setDTSAccessory(String type);
    boolean selectDTSFeaturedAccessory(String model);
    boolean setPredefinedDTSAccessory(int predefined);
    boolean initAccessoryMap();
    String setDTSPresetMode(String mode);
	AccessoryDescriptor getCurrentAccessory();
	List<AccessoryDescriptor> getAccessories();
	int getCurrentAudioRouteType();
	String getPresetMode();
	boolean isDtsEnabled();
	boolean isDtsLibInit();
	int getGEQHz(int type);
	oneway void resetDts();
	oneway void setGEQHz(in int[] args);
	oneway void loadAccessoriesOfCategory(int category);
//	oneway void setEq(in String moduleId, in int[] eq);
//	int[] getEq(in String moduleId);
    Bundle getAudioFxConfiguration(in String moduleId, int configuration);
    void saveAudioFxConfiguration(in String moduleId, int configuration, in Bundle data);

	boolean isUrlIsInWhiteList(String url);

	oneway void registerDtsCallback(IDtsCallback iface);
    oneway void unRegisterDtsCallback(IDtsCallback iface);
    
    Bitmap getNotifyAlbumBitmap();
    oneway void setNotifyAlbumBitmap(in Bitmap b);
	boolean isChangeToHardDecodeEnabled();
    oneway void setChangeToHardDecodeEnabled(boolean changeToHardDecodeEnabled);
    AudioInformation getCurrentAudioInformation();
    oneway void qplayAlbumLoadResult(boolean suc, in Bitmap b, in SongInfo songinfo, int requestID, int packageindex);

	oneway void addNextPlaySong(in MusicPlayList playList, in ExtraInfo extraInfo);
	
	
	AudioInformation getAudioInformation(String filePath);
	
	oneway void playNoMusicList(in SongInfo songinfo);
	oneway void playThenPauseNoMusicList(in SongInfo songinfo);
	oneway void stopNoMusicList();
	oneway void resumeNoMusicList();
	oneway void pauseNoMusicList();
	int getPlayStateNoMusicList();
	SongInfo getPlaySongInfoNoMusicList();
	long getCurPlayPosNoMusicList();
	long seekNoMusicList(long s);

	oneway void updateSongInfoIfSamePlayList(in MusicPlayList list);//权限发生变化后更新播放列表

	oneway void updatePlayListAfterScan(in List<SongInfo> oldSongList, in List<SongInfo> newSongList);

	boolean BluetoothA2DPConnected();
	boolean hasPausedByAudioFocusLoss(boolean reset);
	oneway void notifyMetaChangeToSystem(String title);
	boolean isConnectedToFord();

	oneway void registeFFTCallback(OnFFTDataCaptureListener listener);
    oneway void unRegisterFFTCallback(OnFFTDataCaptureListener listener);

    int getSessionId();

    oneway void startCaptureFFTData();
    oneway void stopCaptureFFTData();

    oneway void playSongChange();

    SpectrumData getFFTData();
    oneway void clearFFTData(int save);

	// For QPlay Auto
	boolean getIsCalling();
	void feedbackMusicHallMusicList(in List<QPlayAutoContentItem> qPlayAutoContentItemList, in int requestID,in int startPage);
	void notifyChange(int id);
	String getFordManagerMaker();
	int transBridgeForQPlay(int cmd);

	// 桌面歌词 已确认可以改为oneway
	void showDeskLyric();
	void goneDeskLyric();
	void openDeskLyric();
	void closeDeskLyric();
	void lockDeskLyric();
	void unlockDeskLyric();
	boolean isDeskLyricLock();

	void increaseDeskLyricOffset();
	void decreaseDeskLyricOffset();
	void resetDeskLyricOffset();

	String getBufferMessage();

	String getCurrentVkey();
	oneway void setQQMusicUIConfig(int width, int height, float density);

	boolean hasPlayedSomeSongs();

	void sendRequestGetShuffleList(int playListType, long playListTypeId);
	void sendRequestGetShuffleListWithRange(int playListType, long playListTypeId, int sin, int ein);

	// 定时关闭
	void setAutoCloseTime(in long time);
	void cancelAutoClose();
	boolean isExitAppTimerRunning();
	long getExitRemainTime();
	
	String getTJReport();
	String getTJTJReport();
	void setFrom3rdParty(boolean from3rdParty);

	oneway void selectSearchLyricToCurrentSong(String lyric, boolean isQRC, String transLyric, String romaLyric, in SongInfo songinfo, String searchId);

	void registerOpenCallback(IQQPlayerOpenCallback cb);
    void unRegisterOpenCallback(IQQPlayerOpenCallback cb);
    
	boolean add2CurrentPlayList(in SongInfo sonInfo);
	long getFirstShuffleSongId(in MusicPlayList playList);
	
	MusicPlayList getPrePlayList();
	long getPrePlayListSize();
	
	int getEffecttypesetting();
	void setEffecttypesetting(int type);
	void setSuperSoundEnabled(in boolean enabled);
	boolean isSuperSoundInitiated();
	int initiateSuperSound();

	int clearPrePlayListInfos();
	boolean getDeskLyric();
	void fixFrom(String from);
	
	String getPlayPath();

	boolean isPlayListEmpty();

	void pushClickStatisticsList(in StaticsList clickStatisticsList);
	void pushExposureStatisticsList(in StaticsList exposureStatisticsList);
	boolean getDesklyricLockStatus();

	// Sound FX
	List<String> getEnabledAudioEffectBuilders();
	boolean setAudioListenerBuilderEnable(String moduleId, in boolean enable);
	boolean isAudioListenerBuilderEnabled(String moduleId);

	Bundle getStrictVkey(in SongInfo songInfo, int downloadfrom, int fetchFrom);
	void invalidateStrictVkeyCache(String streamUrl);
	String getPlayUrl(in SongInfo songInfo, String playUrl, int songRate);

	boolean isCurrentCarAudio();
	int getCurrentAudioRoute();
	String getCurrentVKeyPair();
}

